Index: tools/h5dump/h5dump.c
===================================================================
--- tools/h5dump/h5dump.c	(revision 18506)
+++ tools/h5dump/h5dump.c	(working copy)
@@ -23,8 +23,9 @@
 #include "h5trav.h"
 
 
-/* module-scoped variables */
+/* module-scoped variables 
 const char  *progname = "h5dump";
+*/
 
 /* Macros for displaying objects */
 #define begin_obj(obj,name,begin)                               \
@@ -68,7 +69,7 @@
     } *tables;
 } h5dump_table_list_t;
 
-int                 d_status = EXIT_SUCCESS;
+/*int                 d_status = EXIT_SUCCESS;*/
 static int          unamedtype = 0;     /* shared datatype with no name */
 static h5dump_table_list_t table_list = {0, 0, NULL};
 static table_t      *group_table = NULL, *dset_table = NULL, *type_table = NULL;
@@ -819,7 +820,7 @@
     for(u = 0; u < table_list.nused; u++) {
         /* Release object id */
         if(H5Idec_ref(table_list.tables[u].oid) < 0)
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
 
         /* Free each table */
         free_table(table_list.tables[u].group_table);
@@ -881,8 +882,8 @@
             else
                 printf("\"%s\"", obj->objname);
         } else {
-            error_msg(progname, "unknown committed type.\n");
-            d_status = EXIT_FAILURE;
+            error_msg(h5tools_getprogname(), "unknown committed type.\n");
+            h5tools_setstatus( EXIT_FAILURE);
         }
     } else {
         switch(H5Tget_class(type)) {
@@ -1121,7 +1122,7 @@
 
                 /* Type doesn't match any of above. */
                 printf("unknown_one_character_type;\n ");
-                d_status = EXIT_FAILURE;
+                h5tools_setstatus( EXIT_FAILURE);
 
     done:
                 H5Tclose(str_type);
@@ -1151,7 +1152,7 @@
                     printf("H5T_STD_B64LE");
                 } else {
                     printf("undefined bitfield");
-                    d_status = EXIT_FAILURE;
+                    h5tools_setstatus( EXIT_FAILURE);
                 }
                 break;
 
@@ -1258,7 +1259,7 @@
 
             default:
                 printf("unknown datatype");
-                d_status = EXIT_FAILURE;
+                h5tools_setstatus( EXIT_FAILURE);
                 break;
         }
     } /* end else */
@@ -1401,11 +1402,11 @@
 
     if((attr_id = H5Aopen(oid, attr_name, H5P_DEFAULT)) < 0) {
         indentation(indent + COL);
-        error_msg(progname, "unable to open attribute \"%s\"\n", attr_name);
+        error_msg(h5tools_getprogname(), "unable to open attribute \"%s\"\n", attr_name);
         indentation(indent);
         end_obj(dump_header_format->attributeend,
                 dump_header_format->attributeblockend);
-        d_status = EXIT_FAILURE;
+        h5tools_setstatus( EXIT_FAILURE);
         ret = FAIL;
     } else {
         hid_t type, space;
@@ -1477,9 +1478,9 @@
     /* Open the object with the attribute */
     if((oid = H5Oopen(loc_id, obj_name, H5P_DEFAULT)) < 0) {
         indentation(COL);
-        error_msg(progname, "unable to open object \"%s\"\n", obj_name);
+        error_msg(h5tools_getprogname(), "unable to open object \"%s\"\n", obj_name);
         end_obj(dump_header_format->attributeend, dump_header_format->attributeblockend);
-        d_status = EXIT_FAILURE;
+        h5tools_setstatus( EXIT_FAILURE);
         return FAIL;
     } /* end if */
 
@@ -1504,14 +1505,14 @@
         dump_header_format->attributeblockend);
     } else {
         indentation(COL);
-        error_msg(progname, "unable to open attribute \"%s\"\n", obj_name);
+        error_msg(h5tools_getprogname(), "unable to open attribute \"%s\"\n", obj_name);
         end_obj(dump_header_format->attributeend, dump_header_format->attributeblockend);
-        d_status = EXIT_FAILURE;
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     /* Close object */
     if(H5Oclose(oid) < 0) {
-        d_status = EXIT_FAILURE;
+        h5tools_setstatus( EXIT_FAILURE);
         return FAIL;
     } /* end if */
 
@@ -1559,8 +1560,8 @@
 
         /* Stat the object */
         if(H5Oget_info_by_name(group, name, &oinfo, H5P_DEFAULT) < 0) {
-            error_msg(progname, "unable to get object information for \"%s\"\n", name);
-            d_status = EXIT_FAILURE;
+            error_msg(h5tools_getprogname(), "unable to get object information for \"%s\"\n", name);
+            h5tools_setstatus( EXIT_FAILURE);
             ret = FAIL;
             goto done;
         } /* end if */
@@ -1570,8 +1571,8 @@
         case H5O_TYPE_GROUP:
             if((obj = H5Gopen2(group, name, H5P_DEFAULT)) < 0)
             {
-                error_msg(progname, "unable to dump group \"%s\"\n", name);
-                d_status = EXIT_FAILURE;
+                error_msg(h5tools_getprogname(), "unable to dump group \"%s\"\n", name);
+                h5tools_setstatus( EXIT_FAILURE);
                 ret = FAIL;
             }
             else
@@ -1609,13 +1610,13 @@
                             begin_obj(dump_header_format->datasetbegin, name,
                                       dump_header_format->datasetblockbegin);
                             indentation(indent + COL);
-                            error_msg(progname,
+                            error_msg(h5tools_getprogname(),
                                       "internal error (file %s:line %d)\n",
                                       __FILE__, __LINE__);
                             indentation(indent);
                             end_obj(dump_header_format->datasetend,
                                     dump_header_format->datasetblockend);
-                            d_status = EXIT_FAILURE;
+                            h5tools_setstatus( EXIT_FAILURE);
                             ret = FAIL;
                             H5Dclose(obj);
                             goto done;
@@ -1678,16 +1679,16 @@
                     dump_function_table->dump_dataset_function(obj, name, NULL);
                     H5Dclose(obj);
                 } else {
-                    error_msg(progname, "unable to dump dataset \"%s\"\n", name);
-                    d_status = EXIT_FAILURE;
+                    error_msg(h5tools_getprogname(), "unable to dump dataset \"%s\"\n", name);
+                    h5tools_setstatus( EXIT_FAILURE);
                     ret = FAIL;
                 }
                 break;
 
             case H5O_TYPE_NAMED_DATATYPE:
                 if((obj = H5Topen2(group, name, H5P_DEFAULT)) < 0) {
-                    error_msg(progname, "unable to dump datatype \"%s\"\n", name);
-                    d_status = EXIT_FAILURE;
+                    error_msg(h5tools_getprogname(), "unable to dump datatype \"%s\"\n", name);
+                    h5tools_setstatus( EXIT_FAILURE);
                     ret = FAIL;
                 } else {
                     dump_function_table->dump_named_datatype_function(obj, name);
@@ -1696,8 +1697,8 @@
                 break;
 
             default:
-                error_msg(progname, "unknown object \"%s\"\n", name);
-                d_status = EXIT_FAILURE;
+                error_msg(h5tools_getprogname(), "unknown object \"%s\"\n", name);
+                h5tools_setstatus( EXIT_FAILURE);
                 ret = FAIL;
         }
     } /* end if */
@@ -1717,8 +1718,8 @@
                 }
 
                 if(H5Lget_val(group, name, targbuf, linfo->u.val_size, H5P_DEFAULT) < 0) {
-                    error_msg(progname, "unable to get link value\n");
-                    d_status = EXIT_FAILURE;
+                    error_msg(h5tools_getprogname(), "unable to get link value\n");
+                    h5tools_setstatus( EXIT_FAILURE);
                     ret = FAIL;
                 } else {
                     /* print the value of a soft link */
@@ -1808,8 +1809,8 @@
                     begin_obj(dump_header_format->extlinkbegin, name, dump_header_format->extlinkblockbegin);
 
                 if(H5Lget_val(group, name, targbuf, linfo->u.val_size, H5P_DEFAULT) < 0) {
-                    error_msg(progname, "unable to get external link value\n");
-                    d_status = EXIT_FAILURE;
+                    error_msg(h5tools_getprogname(), "unable to get external link value\n");
+                    h5tools_setstatus( EXIT_FAILURE);
                     ret = FAIL;
                 } /* end if */
                 else {
@@ -1817,8 +1818,8 @@
                     const char *targname;
 
                     if(H5Lunpack_elink_val(targbuf, linfo->u.val_size, NULL, &filename, &targname) < 0) {
-                        error_msg(progname, "unable to unpack external link value\n");
-                        d_status = EXIT_FAILURE;
+                        error_msg(h5tools_getprogname(), "unable to unpack external link value\n");
+                        h5tools_setstatus( EXIT_FAILURE);
                         ret = FAIL;
                     } /* end if */
                     else {
@@ -1950,20 +1951,20 @@
 
     if ((tcpl_id = H5Tget_create_plist(tid)) < 0)
     {
-        error_msg(progname, "error in getting creation property list ID\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting creation property list ID\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     /* query the creation properties for attributes */
     if (H5Pget_attr_creation_order(tcpl_id, &attr_crt_order_flags) < 0)
     {
-        error_msg(progname, "error in getting creation properties\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting creation properties\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     if(H5Pclose(tcpl_id) < 0) {
-        error_msg(progname, "error in closing creation property list ID\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in closing creation property list ID\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
 
@@ -1982,9 +1983,9 @@
         found_obj = search_obj(type_table, oinfo.addr);
 
         if (found_obj == NULL) {
-            error_msg(progname, "internal error (file %s:line %d)\n",
+            error_msg(h5tools_getprogname(), "internal error (file %s:line %d)\n",
                 __FILE__, __LINE__);
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
             goto done;
         }
         else if (found_obj->displayed) {
@@ -2007,14 +2008,14 @@
 
     if( (sort_by == H5_INDEX_CRT_ORDER) && (attr_crt_order_flags & H5P_CRT_ORDER_TRACKED)) {
         if(H5Aiterate2(tid, sort_by, sort_order, NULL, dump_attr_cb, NULL) < 0) {
-            error_msg(progname, "error getting attribute information\n");
-            d_status = EXIT_FAILURE;
+            error_msg(h5tools_getprogname(), "error getting attribute information\n");
+            h5tools_setstatus( EXIT_FAILURE);
         } /* end if */
     } /* end if */
     else {
         if(H5Aiterate2(tid, H5_INDEX_NAME, sort_order, NULL, dump_attr_cb, NULL) < 0) {
-            error_msg(progname, "error getting attribute information\n");
-            d_status = EXIT_FAILURE;
+            error_msg(h5tools_getprogname(), "error getting attribute information\n");
+            h5tools_setstatus( EXIT_FAILURE);
         } /* end if */
     } /* end else */
 
@@ -2056,27 +2057,27 @@
 
     if ((gcpl_id = H5Gget_create_plist(gid)) < 0)
     {
-        error_msg(progname, "error in getting group creation property list ID\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting group creation property list ID\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     /* query the group creation properties for attributes */
     if (H5Pget_attr_creation_order(gcpl_id, &attr_crt_order_flags) < 0)
     {
-        error_msg(progname, "error in getting group creation properties\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting group creation properties\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     /* query the group creation properties */
     if(H5Pget_link_creation_order(gcpl_id, &crt_order_flags) < 0)
     {
-        error_msg(progname, "error in getting group creation properties\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting group creation properties\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     if(H5Pclose(gcpl_id) < 0) {
-        error_msg(progname, "error in closing group creation property list ID\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in closing group creation property list ID\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
 
@@ -2118,9 +2119,9 @@
 
         if (found_obj == NULL) {
             indentation(indent);
-            error_msg(progname, "internal error (file %s:line %d)\n",
+            error_msg(h5tools_getprogname(), "internal error (file %s:line %d)\n",
                 __FILE__, __LINE__);
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
         }
         else if (found_obj->displayed) {
             indentation(indent);
@@ -2133,14 +2134,14 @@
 
             if((sort_by == H5_INDEX_CRT_ORDER) && (attr_crt_order_flags & H5P_CRT_ORDER_TRACKED)) {
                 if(H5Aiterate2(gid, sort_by, sort_order, NULL, dump_attr_cb, NULL) < 0) {
-                    error_msg(progname, "error getting attribute information\n");
-                    d_status = EXIT_FAILURE;
+                    error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                    h5tools_setstatus( EXIT_FAILURE);
                 } /* end if */
             } /* end if */
             else {
                 if(H5Aiterate2(gid, H5_INDEX_NAME, sort_order, NULL, dump_attr_cb, NULL) < 0) {
-                    error_msg(progname, "error getting attribute information\n");
-                    d_status = EXIT_FAILURE;
+                    error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                    h5tools_setstatus( EXIT_FAILURE);
                 } /* end if */
             } /* end else */
 
@@ -2164,14 +2165,14 @@
 
         if((sort_by == H5_INDEX_CRT_ORDER) && (attr_crt_order_flags & H5P_CRT_ORDER_TRACKED)) {
             if(H5Aiterate2(gid, sort_by, sort_order, NULL, dump_attr_cb, NULL) < 0) {
-                error_msg(progname, "error getting attribute information\n");
-                d_status = EXIT_FAILURE;
+                error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                h5tools_setstatus( EXIT_FAILURE);
             } /* end if */
         } /* end if */
         else {
             if(H5Aiterate2(gid, H5_INDEX_NAME, sort_order, NULL, dump_attr_cb, NULL) < 0) {
-                error_msg(progname, "error getting attribute information\n");
-                d_status = EXIT_FAILURE;
+                error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                h5tools_setstatus( EXIT_FAILURE);
             } /* end if */
         } /* end else */
 
@@ -2218,15 +2219,15 @@
 
     if ((dcpl_id = H5Dget_create_plist(did)) < 0)
     {
-        error_msg(progname, "error in getting creation property list ID\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting creation property list ID\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     /* query the creation properties for attributes */
     if (H5Pget_attr_creation_order(dcpl_id, &attr_crt_order_flags) < 0)
     {
-        error_msg(progname, "error in getting creation properties\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "error in getting creation properties\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     indentation(indent);
@@ -2280,14 +2281,14 @@
 
         if( (sort_by == H5_INDEX_CRT_ORDER) && (attr_crt_order_flags & H5P_CRT_ORDER_TRACKED)) {
             if(H5Aiterate2(did, sort_by, sort_order, NULL, dump_attr_cb, NULL) < 0) {
-                error_msg(progname, "error getting attribute information\n");
-                d_status = EXIT_FAILURE;
+                error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                h5tools_setstatus( EXIT_FAILURE);
             } /* end if */
         } /* end if */
         else {
             if(H5Aiterate2(did, H5_INDEX_NAME, sort_order, NULL, dump_attr_cb, NULL) < 0) {
-                error_msg(progname, "error getting attribute information\n");
-                d_status = EXIT_FAILURE;
+                error_msg(h5tools_getprogname(), "error getting attribute information\n");
+                h5tools_setstatus( EXIT_FAILURE);
             } /* end if */
         } /* end else */
 
@@ -2598,8 +2599,8 @@
 
     if (status == FAIL) {
         indentation(indent + COL);
-        error_msg(progname, "unable to print data\n");
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "unable to print data\n");
+        h5tools_setstatus( EXIT_FAILURE);
     }
 
     indentation(indent);
@@ -3554,10 +3555,10 @@
             begin_obj(dump_header_format->datasetbegin, real_name,
                 dump_header_format->datasetblockbegin);
             indentation(COL);
-            error_msg(progname, "unable to open dataset \"%s\"\n", real_name);
+            error_msg(h5tools_getprogname(), "unable to open dataset \"%s\"\n", real_name);
             end_obj(dump_header_format->datasetend,
                 dump_header_format->datasetblockend);
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
         }
         return;
     } /* end if */
@@ -3624,8 +3625,8 @@
 
                 if ( sset->stride[i] < sset->block[i] )
                 {
-                    error_msg(progname, "wrong subset selection; blocks overlap\n");
-                    d_status = EXIT_FAILURE;
+                    error_msg(h5tools_getprogname(), "wrong subset selection; blocks overlap\n");
+                    h5tools_setstatus( EXIT_FAILURE);
                     return;
 
                 }
@@ -3659,13 +3660,13 @@
             }
         }
         else
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
     }
     else
         dump_dataset(dsetid, real_name, sset);
 
     if(H5Dclose(dsetid) < 0)
-        d_status = EXIT_FAILURE;
+        h5tools_setstatus( EXIT_FAILURE);
 }
 
 /*-------------------------------------------------------------------------
@@ -3701,9 +3702,9 @@
         {
             begin_obj(dump_header_format->groupbegin, real_name, dump_header_format->groupblockbegin);
             indentation(COL);
-            error_msg(progname, "unable to open group \"%s\"\n", real_name);
+            error_msg(h5tools_getprogname(), "unable to open group \"%s\"\n", real_name);
             end_obj(dump_header_format->groupend, dump_header_format->groupblockend);
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
         }
     }
     else
@@ -3721,7 +3722,7 @@
         dump_group(gid, real_name);
 
         if(H5Gclose(gid) < 0)
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
     } /* end else */
 } /* end handle_groups() */
 
@@ -3745,11 +3746,11 @@
     H5L_info_t linfo;
 
     if(H5Lget_info(fid, links, &linfo, H5P_DEFAULT) < 0) {
-        error_msg(progname, "unable to get link info from \"%s\"\n", links);
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "unable to get link info from \"%s\"\n", links);
+        h5tools_setstatus( EXIT_FAILURE);
     } else if(linfo.type == H5L_TYPE_HARD) {
-        error_msg(progname, "\"%s\" is a hard link\n", links);
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "\"%s\" is a hard link\n", links);
+        h5tools_setstatus( EXIT_FAILURE);
     } else {
         char *buf = HDmalloc(linfo.u.val_size);
 
@@ -3761,9 +3762,9 @@
                 if(H5Lget_val(fid, links, buf, linfo.u.val_size, H5P_DEFAULT) >= 0)
                     printf("LINKTARGET \"%s\"\n", buf);
                 else {
-                    error_msg(progname, "h5dump error: unable to get link value for \"%s\"\n",
+                    error_msg(h5tools_getprogname(), "h5dump error: unable to get link value for \"%s\"\n",
                               links);
-                    d_status = EXIT_FAILURE;
+                    h5tools_setstatus( EXIT_FAILURE);
                 }
                 end_obj(dump_header_format->softlinkend,
                         dump_header_format->softlinkblockend);
@@ -3787,12 +3788,12 @@
                         indentation(COL);
                         printf("TARGETPATH \"%s\"\n", elink_path);
                     } else {
-                        error_msg(progname, "h5dump error: unable to unpack external link value for \"%s\"\n", links);
-                        d_status = EXIT_FAILURE;
+                        error_msg(h5tools_getprogname(), "h5dump error: unable to unpack external link value for \"%s\"\n", links);
+                        h5tools_setstatus( EXIT_FAILURE);
                     }
                 } else {
-                    error_msg(progname, "h5dump error: unable to get external link value for \"%s\"\n", links);
-                    d_status = EXIT_FAILURE;
+                    error_msg(h5tools_getprogname(), "h5dump error: unable to get external link value for \"%s\"\n", links);
+                    h5tools_setstatus( EXIT_FAILURE);
                 }
                 end_obj(dump_header_format->extlinkend,
                         dump_header_format->extlinkblockend);
@@ -3868,10 +3869,10 @@
                 begin_obj(dump_header_format->datatypebegin, real_name,
                     dump_header_format->datatypeblockbegin);
                 indentation(COL);
-                error_msg(progname, "unable to open datatype \"%s\"\n", real_name);
+                error_msg(h5tools_getprogname(), "unable to open datatype \"%s\"\n", real_name);
                 end_obj(dump_header_format->datatypeend,
                     dump_header_format->datatypeblockend);
-                d_status = EXIT_FAILURE;
+                h5tools_setstatus( EXIT_FAILURE);
             }
         }
         else
@@ -3888,7 +3889,7 @@
         dump_named_datatype(type_id, real_name);
 
         if(H5Tclose(type_id) < 0)
-            d_status = EXIT_FAILURE;
+            h5tools_setstatus( EXIT_FAILURE);
     }
 }
 
@@ -3920,7 +3921,7 @@
 
      /* no arguments */
     if (argc == 1) {
-        usage(progname);
+        usage(h5tools_getprogname());
         leave(EXIT_FAILURE);
     }
 
@@ -3970,7 +3971,7 @@
             display_char = TRUE;
             break;
         case 'V':
-            print_version(progname);
+            print_version(h5tools_getprogname());
             leave(EXIT_SUCCESS);
             break;
         case 'w':
@@ -4046,13 +4047,13 @@
         case 'o':
             if ( bin_output ) {
                 if (set_output_file(opt_arg, 1) < 0) {
-                    usage(progname);
+                    usage(h5tools_getprogname());
                     leave(EXIT_FAILURE);
                 }
             }
             else {
                 if (set_output_file(opt_arg, 0) < 0) {
-                    usage(progname);
+                    usage(h5tools_getprogname());
                     leave(EXIT_FAILURE);
                 }
             }
@@ -4066,7 +4067,7 @@
             if ( opt_arg != NULL) {
                 if ( ( bin_form = set_binary_form(opt_arg)) < 0) {
                     /* failed to set binary form */
-                    usage(progname);
+                    usage(h5tools_getprogname());
                     leave(EXIT_FAILURE);
                 }
             }
@@ -4074,7 +4075,7 @@
             if (outfname!=NULL) {
                 if (set_output_file(outfname, 1) < 0)  {
                     /* failed to set output file */
-                    usage(progname);
+                    usage(h5tools_getprogname());
                     leave(EXIT_FAILURE);
                 }
 
@@ -4085,7 +4086,7 @@
         case 'q':
             if ( ( sort_by = set_sort_by(opt_arg)) < 0) {
                 /* failed to set "sort by" form */
-                usage(progname);
+                usage(h5tools_getprogname());
                 leave(EXIT_FAILURE);
             }
             break;
@@ -4093,7 +4094,7 @@
         case 'z':
             if ( ( sort_order = set_sort_order(opt_arg)) < 0) {
                 /* failed to set "sort order" form */
-                usage(progname);
+                usage(h5tools_getprogname());
                 leave(EXIT_FAILURE);
             }
             break;
@@ -4131,7 +4132,7 @@
             /* specify XML namespace (default="hdf5:"), or none */
             /* To Do: check format of this value?  */
         if (!useschema) {
-                usage(progname);
+                usage(h5tools_getprogname());
                 leave(EXIT_FAILURE);
         }
         if (strcmp(opt_arg,":") == 0) {
@@ -4150,7 +4151,7 @@
             struct subset_t *s;
 
             if (!last_was_dset) {
-                error_msg(progname,
+                error_msg(h5tools_getprogname(),
                           "option `-%c' can only be used after --dataset option\n",
                           opt);
                 leave(EXIT_FAILURE);
@@ -4198,11 +4199,11 @@
         /** end subsetting parameters **/
 
         case 'h':
-            usage(progname);
+            usage(h5tools_getprogname());
             leave(EXIT_SUCCESS);
         case '?':
         default:
-            usage(progname);
+            usage(h5tools_getprogname());
             leave(EXIT_FAILURE);
         }
     }
@@ -4210,8 +4211,8 @@
 parse_end:
     /* check for file name to be processed */
     if (argc <= opt_ind) {
-        error_msg(progname, "missing file name\n");
-        usage(progname);
+        error_msg(h5tools_getprogname(), "missing file name\n");
+        usage(h5tools_getprogname());
         leave(EXIT_FAILURE);
     }
     return hand;
@@ -4291,6 +4292,9 @@
  *        September 2007
  *        list objects in requested order (creation order or alphabetically)
  *
+ *        Werner Benger
+ *        March 2010
+ *        Call h5tools functions from shared library instead of static linking.
  *-------------------------------------------------------------------------
  */
 int
@@ -4305,6 +4309,8 @@
     int                 i;
     unsigned            u;
 
+    h5tools_setprogname("h5dump");
+    h5tools_setstatus(EXIT_SUCCESS);
     dump_header_format = &standardformat;
     dump_function_table = &ddl_function_table;
 
@@ -4318,43 +4324,43 @@
 
     if ( bin_output && outfname == NULL )
     {
-        error_msg(progname, "binary output requires a file name, use -o <filename>\n");
+        error_msg(h5tools_getprogname(), "binary output requires a file name, use -o <filename>\n");
         leave(EXIT_FAILURE);
     }
 
     /* Check for conflicting options */
     if (doxml) {
         if (!display_all) {
-            error_msg(progname, "option \"%s\" not available for XML\n",
+            error_msg(h5tools_getprogname(), "option \"%s\" not available for XML\n",
                     "to display selected objects");
             leave(EXIT_FAILURE);
         } else if (display_bb) {
-            error_msg(progname, "option \"%s\" not available for XML\n",
+            error_msg(h5tools_getprogname(), "option \"%s\" not available for XML\n",
                     "--boot-block");
             leave(EXIT_FAILURE);
         } else if (display_oid == 1) {
-            error_msg(progname, "option \"%s\" not available for XML\n",
+            error_msg(h5tools_getprogname(), "option \"%s\" not available for XML\n",
                     "--object-ids");
             leave(EXIT_FAILURE);
         } else if (display_char == TRUE) {
-            error_msg(progname, "option \"%s\" not available for XML\n",
+            error_msg(h5tools_getprogname(), "option \"%s\" not available for XML\n",
                     "--string");
             leave(EXIT_FAILURE);
         } else if (usingdasho) {
-            error_msg(progname, "option \"%s\" not available for XML\n",
+            error_msg(h5tools_getprogname(), "option \"%s\" not available for XML\n",
                     "--output");
             leave(EXIT_FAILURE);
         }
     } else {
         if (xml_dtd_uri) {
-            warn_msg(progname, "option \"%s\" only applies with XML: %s\n",
+            warn_msg(h5tools_getprogname(), "option \"%s\" only applies with XML: %s\n",
                      "--xml-dtd", xml_dtd_uri);
         }
     }
 
     if (argc <= opt_ind) {
-        error_msg(progname, "missing file name\n");
-        usage(progname);
+        error_msg(h5tools_getprogname(), "missing file name\n");
+        usage(h5tools_getprogname());
         leave(EXIT_FAILURE);
     }
     fname = HDstrdup(argv[opt_ind]);
@@ -4362,7 +4368,7 @@
     fid = h5tools_fopen(fname, H5F_ACC_RDONLY, H5P_DEFAULT, driver, NULL, 0);
 
     if (fid < 0) {
-        error_msg(progname, "unable to open file \"%s\"\n", fname);
+        error_msg(h5tools_getprogname(), "unable to open file \"%s\"\n", fname);
         leave(EXIT_FAILURE);
     }
 
@@ -4388,7 +4394,7 @@
             }
         } else {
             if (useschema && strcmp(xmlnsprefix,"")) {
-                error_msg(progname, "Cannot set Schema URL for a qualified namespace--use -X or -U option with -D \n");
+                error_msg(h5tools_getprogname(), "Cannot set Schema URL for a qualified namespace--use -X or -U option with -D \n");
                 leave(EXIT_FAILURE);
             }
         }
@@ -4397,15 +4403,15 @@
 
     /* Get object info for root group */
     if(H5Oget_info_by_name(fid, "/", &oi, H5P_DEFAULT) < 0) {
-        error_msg(progname, "internal error (file %s:line %d)\n", __FILE__, __LINE__);
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "internal error (file %s:line %d)\n", __FILE__, __LINE__);
+        h5tools_setstatus(EXIT_FAILURE);
         goto done;
     }
 
     /* Initialize object tables */
     if(table_list_add(fid, oi.fileno) < 0) {
-        error_msg(progname, "internal error (file %s:line %d)\n", __FILE__, __LINE__);
-        d_status = EXIT_FAILURE;
+        error_msg(h5tools_getprogname(), "internal error (file %s:line %d)\n", __FILE__, __LINE__);
+        h5tools_setstatus( EXIT_FAILURE);
         goto done;
     }
     group_table = table_list.tables[0].group_table;
@@ -4467,8 +4473,8 @@
     {
         if((gid = H5Gopen2(fid, "/", H5P_DEFAULT)) < 0)
         {
-            error_msg(progname, "unable to open root group\n");
-            d_status = EXIT_FAILURE;
+            error_msg(h5tools_getprogname(), "unable to open root group\n");
+            h5tools_setstatus( EXIT_FAILURE );
         }
         else
         {
@@ -4479,8 +4485,8 @@
 
         if(H5Gclose(gid) < 0)
         {
-            error_msg(progname, "unable to close root group\n");
-            d_status = EXIT_FAILURE;
+            error_msg(h5tools_getprogname(), "unable to close root group\n");
+            h5tools_setstatus( EXIT_FAILURE );
         }
 
 
@@ -4489,8 +4495,8 @@
     {
         /* Note: this option is not supported for XML */
         if(doxml) {
-            error_msg(progname, "internal error (file %s:line %d)\n", __FILE__, __LINE__);
-            d_status = EXIT_FAILURE;
+            error_msg(h5tools_getprogname(), "internal error (file %s:line %d)\n", __FILE__, __LINE__);
+            h5tools_setstatus( EXIT_FAILURE);
             goto done;
         } /* end if */
 
